//
//  CalendarViewController.m
//  Gensys iOS Universal
//
//  Created by Daan Vermeulen on 19/10/15.
//  Copyright © 2015 SPS Gensys B.V. All rights reserved.
//

#import "CalendarViewController.h"
#import "NSDate+Gensys.h"
#import "CalendarTheme.h"
#import "InternalActivityDetailsViewController.h"
#import "SDSActivityDetailsViewController.h"

@interface CalendarViewController ()

@end

@implementation CalendarViewController

- (void)viewWillAppear:(BOOL)animated
{
    if (!IS_IPAD)
        self.bottomToolbarBottomConstraint.constant = self.tabBarController.tabBar.frame.size.height;
    [super viewWillAppear:animated];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    months = [[NSMutableArray alloc] init];
    
    // TOOLBAR CONFIGURATION FOR IPHONE AND IPAD
    
//    NSString *todayTitle = [@"Today" localized];
//    UIBarButtonItem *todayButton = [[UIBarButtonItem alloc] initWithTitle:todayTitle style:UIBarButtonItemStylePlain target:self action:@selector(todayButtonTapped:)];
//    
//    UIBarButtonItem *optionsButton = [[UIBarButtonItem alloc] initWithTitle:[@"Options" localized]
//                                                                      style:UIBarButtonItemStylePlain
//                                                                     target:self
//                                                                     action:@selector(optionsPressed:)];
//    
//    UIBarButtonItem *createActivityButton = [[UIBarButtonItem alloc]
//                                             initWithBarButtonSystemItem:UIBarButtonSystemItemAdd
//                                             target:self
//                                             action:@selector(createInternalActivityButtonPressed:)];
//    
//    UIBarButtonItem *refreshButton = [[UIBarButtonItem alloc]
//                                             initWithBarButtonSystemItem:UIBarButtonSystemItemRefresh
//                                             target:self
//                                             action:@selector(refresh)];
//    
//    UIBarButtonItem *flexibleSpace = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
//    UIBarButtonItem *flexibleSpace2 = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemFlexibleSpace target:nil action:nil];
//    
//    _periodSegmentView = [[UISegmentedControl alloc] initWithItems:@[[@"Year" localized], [@"Month" localized], [@"Week" localized], [@"Day" localized]]];
//    UIBarButtonItem *periodSegmentBarButtonItem = [[UIBarButtonItem alloc] initWithCustomView:_periodSegmentView];
//    _topToolbar.clipsToBounds = true;
//    
//    if (IS_IPAD)
//    {
//        if ([[Context sharedContext].currentSettingsNew canAddActivity])
//            [_topToolbar setItems:@[todayButton, optionsButton, refreshButton, flexibleSpace, periodSegmentBarButtonItem, flexibleSpace2, createActivityButton]];
//        else
//            [_topToolbar setItems:@[todayButton, optionsButton, refreshButton, flexibleSpace, periodSegmentBarButtonItem, flexibleSpace2]];
//        [_bottomToolbar setHidden:true];
//    }
//    else
//    {
//        [_topToolbar setItems:@[flexibleSpace, periodSegmentBarButtonItem, flexibleSpace2]];
//        if ([[Context sharedContext].currentSettingsNew canAddActivity])
//            [_bottomToolbar setItems:@[todayButton, optionsButton, refreshButton, flexibleSpace, createActivityButton]];
//        else
//            [_bottomToolbar setItems:@[todayButton, optionsButton, refreshButton, flexibleSpace]];
//    }
//
//    _customTheme = [[CalendarTheme alloc] init];
//    
//    self.view.backgroundColor = [UIColor colorWithWhite:.97 alpha:1];
//    
//    [_periodSegmentView addTarget:self action:@selector(navigate) forControlEvents:UIControlEventValueChanged];
    
    CGFloat top = _topToolbar.frame.origin.y + _topToolbar.frame.size.height;
    CGFloat bottom = IS_IPAD ? 0 : self.bottomToolbar.frame.size.height + self.tabBarController.tabBar.frame.size.height;
    _calendar = [[IGCalendarView alloc] initWithFrame: CGRectMake(0, top, self.view.frame.size.width, self.view.frame.size.height - top - bottom)];
    _calendar.theme = _customTheme;
    _calendar.autoresizingMask = UIViewAutoresizingFlexibleHeight | UIViewAutoresizingFlexibleWidth;
//    _calendar.monthViewDayClickAction = IGCalendarMonthViewDayClickActionNavigateToWeek;
    
    _appts = [[NSMutableArray alloc] init];

//    NSDate *date = [NSDate date];
//    NSCalendar *calendar = [NSCalendar currentCalendar];
//    NSDateComponents *components = [calendar components:NSCalendarUnitYear fromDate:date];
//    NSInteger minYear = [components year] - 1;
//    NSInteger maxYear = [components year] + 1;
//    _calendar.dayViewHourTimeFormat = IGCalendarDayViewTimeFormat24;
//    
//    _calendar.minYear = minYear;
//    _calendar.maxYear = maxYear;
//
//    [_calendar setDayViewInitialScrollStartHour:8.0];
//    _calendar.styleWorkingHours = true;
//    
//    Networking * networking = [Networking networking];
//    [networking postRequest:nil action:@"GetWorkingHours" success:^(NSString * xmlResponse) {
//        XmlParser * xmlParser = [[XmlParser alloc] init];
//        NSArray * startEndTime = [xmlParser responseToWorkingHours:xmlResponse];
//        
//        if (startEndTime && startEndTime.count == 2)
//        {
//            NSDateComponents * startComponents = [[NSCalendar currentCalendar] components:(NSCalendarUnitHour | NSCalendarUnitMinute) fromDate:[startEndTime objectAtIndex:0]];
//            NSDateComponents * endComponents = [[NSCalendar currentCalendar] components:(NSCalendarUnitHour | NSCalendarUnitMinute) fromDate:[startEndTime objectAtIndex:1]];
//            _calendar.startWorkingHour = startComponents.hour + (startComponents.minute / 60.0);
//            _calendar.endWorkingHour = endComponents.hour + (endComponents.minute / 60.0);
//            [_calendar setDayViewInitialScrollStartHour:_calendar.startWorkingHour];
//        }
//    } failure:^(NSError * error) {
//        NSLog(@"FAILED ACTION");
//    }];
    
//    _calendar.dayViewInitialScrollLocation = IGCalendarDayViewInitialScrollLocationFirstAppointment;

    _dataSources = [[NSMutableArray alloc]init];
    [_dataSources addObject:self];


        [self.view addSubview:_calendar];
        _calendar.delegate = self;
    _calendar.appointmentDataSources = _dataSources;

    [_calendar navigateToDate:[NSDate date] forType:IS_IPAD ? IGCalendarViewDisplayTypeWeek : IGCalendarViewDisplayTypeDay];
}

//- (void)todayButtonTapped:(id)sender
//{
//    [_calendar navigateToDate:[NSDate date] forType:IGCalendarViewDisplayTypeDay animate:true];
//}
//
//- (void)createInternalActivityButtonPressed:(UIBarButtonItem *)sender
//{
//    InternalActivityDetailsViewController * activityVC = [[InternalActivityDetailsViewController alloc] init];
//    UINavigationController * activityNav = [[UINavigationController alloc] initWithRootViewController:activityVC];
//    activityNav.modalPresentationStyle = UIModalPresentationPopover;
//    if (_calendar.calendarType == IGCalendarViewDisplayTypeDay)
//        activityVC.SelectedDate = _calendar.currentDate;
//    else
//        activityVC.SelectedDate = [NSDate date];
//    activityVC.Activity = nil;
//    activityVC.screenMode = screenAddInternalActivity;
//    activityVC.delegate = self;
//    [activityVC refreshView];
//    activityVC.preferredContentSize = CGSizeMake(500, 600);
//    [self presentViewController:activityNav animated:true completion:nil];
//    if (activityNav.popoverPresentationController)
//    {
//        activityNav.popoverPresentationController.barButtonItem = sender;
//        activityNav.popoverPresentationController.permittedArrowDirections = UIPopoverArrowDirectionAny;
//        activityNav.popoverPresentationController.delegate = self;
//    }
//}
//
//- (void)optionsPressed:(UIBarButtonItem *)sender
//{
//    UIAlertController * alert = [UIAlertController
//                                 alertControllerWithTitle:nil
//                                 message:nil
//                                 preferredStyle:UIAlertControllerStyleActionSheet];
//    
//    
//    
//    UIAlertController *alertController;
//    UIAlertAction *adminAction;
//    UIAlertAction *cancelAction;
//    
//    alertController = [UIAlertController alertControllerWithTitle:nil
//                                                          message:nil
//                                                   preferredStyle:UIAlertControllerStyleActionSheet];
//    adminAction = [UIAlertAction actionWithTitle:includeAdministrativeActivities ? [@"HideAdminActivities" localized] : [@"ShowAdminActivities" localized]
//                                             style:UIAlertActionStyleDefault
//                                           handler:^(UIAlertAction *action) {
//                                               includeAdministrativeActivities = !includeAdministrativeActivities;
//                                               [_appts removeAllObjects];
//                                               [months removeAllObjects];
//                                               [_calendar invalidate];
//                                           }];
//    cancelAction = [UIAlertAction actionWithTitle:[@"Cancel" localized]
//                                           style:UIAlertActionStyleCancel
//                                         handler:^(UIAlertAction *action) {
//                                             // Do nothing, continue creating the activity.
//                                         }];
//    [alertController addAction:adminAction];
//    [alertController addAction:cancelAction];
//    [alertController setModalPresentationStyle:UIModalPresentationPopover];
//    
//    UIPopoverPresentationController *popPresenter = [alertController
//                                                     popoverPresentationController];
//    popPresenter.barButtonItem = sender;
//    
//    [self presentViewController:alertController animated:YES completion:nil];
//}

- (UIColor *)colorForAppointmentsInIGCalendarView:(IGCalendarView *)calView
{
    return [UIColor redColor];
}

//// The dayView was navigated to, update the tab bar.
//-(void)calendarView:(IGCalendarView *)calView dayChanged:(NSDate *)date
//{
//    _periodSegmentView.selectedSegmentIndex = 3;
//}
//
//-(void)calendarView:(IGCalendarView *)calView weekChanged:(NSDate *)date
//{
//    _periodSegmentView.selectedSegmentIndex = 2;
//}
//
//// The monthView was navigated to, update the tab bar.
//-(void)calendarView:(IGCalendarView *)calView monthChanged:(NSDate *)date
//{
//    _periodSegmentView.selectedSegmentIndex = 1;
//}
//
//// The yearView was navigated to, update the tab bar.
//-(void)calendarView:(IGCalendarView *)calView yearChanged:(NSDate *)date
//{
//    _periodSegmentView.selectedSegmentIndex = 0;
//}

//-(void)navigate
//{
//    // The segements selected index changed.
//    NSInteger index = [_periodSegmentView selectedSegmentIndex];
//    
//    // Grab the current date from the calendar.
//    NSDate* date = [_calendar currentDate];
//    
//    if(index == 0) // Year
//    {
//        // Navigate to the YearView
//        [_calendar navigateToDate:date forType:IGCalendarViewDisplayTypeYear animate:true];
//    }
//    else if(index == 1) // Month
//    {
//        // Navigate to the MonthView
//        [_calendar navigateToDate:date forType:IGCalendarViewDisplayTypeMonth animate:true];
//    }
//    else if(index == 2) // Month
//    {
//        // Navigate to the MonthView
//        [_calendar navigateToDate:date forType:IGCalendarViewDisplayTypeWeek animate:true];
//    }
//    else // Day
//    {
//        // Navigate to the DayView
//        [_calendar navigateToDate:date forType:IGCalendarViewDisplayTypeDay animate:true];
//    }
//}

//-(NSDate*)resolveDateInYearViewForPoint:(CGPoint)point
//{
//    return nil;
//}

-(void)calendarView:(IGCalendarView *)calView asyncAppointmentRequest:(IGCalendarAppointmentRequest *)request ofType:(IGCalendarAppointmentRequestType)requestType
{
//    unsigned int flags = NSCalendarUnitYear | NSCalendarUnitMonth;
//    NSCalendar* calendar = [NSCalendar currentCalendar];
//    NSDateComponents* components = [calendar components:flags fromDate:request.start];
//    
//    NSDate* strippedRequestDate = [calendar dateFromComponents:components];
//    
//    bool monthExists = false;
//    for (NSDate * date in months)
//    {
//        if ([date timeIntervalSince1970] == [[strippedRequestDate toFirstDayOfMonth] timeIntervalSince1970])
//        {
//            monthExists = true;
//        }
//    }
//    
//    if (monthExists)
//    {
//        NSLog(@"Month exist request.start == %@", request.start);
//        NSTimeInterval min = [request.start timeIntervalSince1970];
//        NSTimeInterval max = [request.end timeIntervalSince1970];
//        NSMutableArray* returnAppts = [[NSMutableArray alloc]init];
//        for (IGCalendarAppointment* appt in _appts)
//        {
//            NSTimeInterval current = [appt.startTime timeIntervalSince1970];
//            if(current >= min && current <= max)
//            {
//                NSLog(@"Appt added: %@ - %@", appt.startTime, appt.endTime);
//                [returnAppts addObject:appt];
//            }
//        }
//        NSLog(@"Month exist request.end == %@", request.end);
//        NSArray* appts = [NSArray arrayWithArray:returnAppts];
//
//        [[NSOperationQueue mainQueue] addOperation: [NSBlockOperation blockOperationWithBlock:^(void)
//                                                     {
//        [request provideAppointments:appts];
//                                                     }]];
//    }
//    else
//    {
//        NSLog(@"Network request.start == %@", request.start);
//        [months addObject:[strippedRequestDate toFirstDayOfMonth]];
//    
//        PostParameters * params = [[PostParameters alloc] init];
//        [params.params setObject:[NSDate dateToServerStr:[strippedRequestDate toFirstDayOfMonth]] forKey:@"startdate"];
//        [params.params setObject:[NSDate dateToServerStr:[strippedRequestDate toLastDayOfMonth]] forKey:@"enddate"];
//        [params.params setObject:@"false" forKey:@"includefollowups"];
//        [params.params setObject:includeAdministrativeActivities ? @"true" : @"false" forKey:@"includeadminactivities"];
//        Networking * networking = [Networking networking];
//        [networking postRequest:params action:@"GetCalendarActivities" success:^(NSString * xmlResponse) {
//            [_appts addObjectsFromArray:[[Context sharedContext].webservice getCalendarActivities:xmlResponse]];
//            [[NSOperationQueue mainQueue] addOperation: [NSBlockOperation blockOperationWithBlock:^(void)
//                                                         {
//            NSTimeInterval min = [request.start timeIntervalSince1970];
//            NSTimeInterval max = [request.end timeIntervalSince1970];
//            NSMutableArray* returnAppts = [[NSMutableArray alloc]init];
//            for (IGCalendarAppointment* appt in _appts)
//            {
//                NSTimeInterval current = [appt.startTime timeIntervalSince1970];
//                if(current >= min && current <= max)
//                {
//                    NSLog(@"Netw. Appt added: %@ - %@", appt.startTime, appt.endTime);
//                    [returnAppts addObject:appt];
//                }
//            }
//            NSLog(@"Network request.end == %@", request.end);
//            NSArray* appts = [NSArray arrayWithArray:returnAppts];
//            [request provideAppointments:appts];
//                                                         }]];
//        } failure:^(NSError * error) {
//            NSLog(@"FAILED ACTION");
//            [months removeObject:strippedRequestDate];
//        }];
//    }
}

//- (BOOL)popoverPresentationControllerShouldDismissPopover:(UIPopoverPresentationController *)popoverPresentationController
//{
//    return false;
//}
//
//- (void)refresh:(NSDate *)startDate EndDate:(NSDate *)endDate
//{
//    NSDate * filterStartDate = [startDate toBeginningOfDay];
//    NSDate * filterEndDate = [endDate toBeginningOfDay];
//    
//    NSCalendar *calendar = [NSCalendar currentCalendar];
//    NSDateComponents *components = [calendar components:NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay|NSCalendarUnitHour|NSCalendarUnitMinute|NSCalendarUnitSecond fromDate:filterEndDate];
//    [components setDay:components.day+1];
//    filterEndDate = [calendar dateFromComponents:components];
//    
//    [_appts filterUsingPredicate:[NSPredicate predicateWithFormat:@"(startTime < %@) OR (startTime > %@)", filterStartDate, filterEndDate]];
//
//    PostParameters * params = [[PostParameters alloc] init];
//    [params.params setObject:[NSDate dateToServerStr:filterStartDate] forKey:@"startdate"];
//    [params.params setObject:[NSDate dateToServerStr:filterEndDate] forKey:@"enddate"];
//    [params.params setObject:@"false" forKey:@"includefollowups"];
//    [params.params setObject:includeAdministrativeActivities ? @"true" : @"false" forKey:@"includeadminactivities"];
//    Networking * networking = [Networking networking];
//    [networking postRequest:params action:@"GetCalendarActivities" success:^(NSString * xmlResponse) {
//        [_appts addObjectsFromArray:[[Context sharedContext].webservice getCalendarActivities:xmlResponse]];
//        [_calendar invalidate];
//    } failure:^(NSError * error) {
//        NSLog(@"FAILED ACTION");
//    }];
//}
//
//- (void)refresh
//{
//    [months removeAllObjects];
//    [_appts removeAllObjects];
//    [_calendar invalidate];
//}
//
//- (void)calendarView:(IGCalendarView *)calView appointmentTapped:(IGCalendarAppointment *)appt fromDataSource:(id<IGCalendarAppointmentDataSource>)dataSource withBounds:(CGRect)rect forDay:(NSDate *)date
//{
//    if ([[appt.miscProperties valueForKey:@"CanModify"] boolValue])
//    {
//        switch ([[appt.miscProperties valueForKey:@"ActivityType"] intValue])
//        {
//            case 0:
//            {
//                SDSActivityDetailsViewController * activityVC = [[SDSActivityDetailsViewController alloc] init];
//                UINavigationController * activityNav = [[UINavigationController alloc] initWithRootViewController:activityVC];
//                activityNav.modalPresentationStyle = UIModalPresentationPopover;
//                SDS_Activity * activity = [[SDS_Activity alloc] init];
//                activity.ActivityId = appt.identifier;
//                activityVC.Activity = activity;
//                activityVC.screenMode = screenModifyActivityDetails;
//                activityVC.delegateCalendar = self;
//                [activityVC refreshView];
//                activityVC.preferredContentSize = CGSizeMake(500, 600);
//                [self presentViewController:activityNav animated:true completion:nil];
//                if (activityNav.popoverPresentationController)
//                {
//                    activityNav.popoverPresentationController.sourceRect = rect;
//                    activityNav.popoverPresentationController.sourceView = calView;
//                    activityNav.popoverPresentationController.permittedArrowDirections = UIPopoverArrowDirectionAny;
//                    activityNav.popoverPresentationController.delegate = self;
//                }
//            }
//                break;
//            default:
//                break;
//        }
//    }
//}
//
//-(NSString*)calendarView:(IGCalendarView *)calView titleLabelForDate:(NSDate*)date forDisplayType:(IGCalendarViewDisplayType)displayType
//{
//    if (displayType == IGCalendarViewDisplayTypeDay)
//    {
//        NSCalendar *calendar = [NSCalendar currentCalendar];
//        NSDateComponents *components = [calendar components:NSCalendarUnitYear|NSCalendarUnitMonth|NSCalendarUnitDay|NSCalendarUnitHour|NSCalendarUnitMinute|NSCalendarUnitSecond fromDate:date];
//        [components setDay:components.day+1];
//        NSDate * endDate = [calendar dateFromComponents:components];
//        
//        
//        NSArray * dayActivities = [_appts filteredArrayUsingPredicate:[NSPredicate predicateWithFormat:@"(startTime >= %@) AND (endTime <= %@)", date, endDate]];
//
//        NSTimeInterval totalTime = 0;
//        for (IGCalendarAppointment * appt in dayActivities)
//        {
//            NSDate * originalEndDate = [appt.miscProperties objectForKey:@"OriginalEndDate"];
//            totalTime += ([originalEndDate timeIntervalSince1970] - [appt.startTime timeIntervalSince1970]);
//        }
//        
//        NSInteger totalTimeRounded = totalTime;
//        int hours = totalTimeRounded / 3600;
//        int minutes = (totalTimeRounded / 60) % 60;
//        
//        NSDateFormatter * dFormatter = [[NSDateFormatter alloc] init];
//        [dFormatter setDateFormat:@"d MMMM, y"];
//        
//        if (IS_IPAD)
//        {
//            if (minutes > 0)
//                return [NSString stringWithFormat:[@"CalendarDateHoursMinutes" localized], [dFormatter stringFromDate:date], hours, minutes];
//            else
//                return [NSString stringWithFormat:[@"CalendarDateHours" localized], [dFormatter stringFromDate:date], hours];
//        }
//        else
//        {
//            return [NSString stringWithFormat:@"%@ (%i:%02i)", [dFormatter stringFromDate:date], hours, minutes];
//        }
//    }
//    else
//        return nil;
//}

@end
